#include "api/df_logging.h"
#include "datafox_library_iv.h"

DF_API_EXTERN_DECORATE void DF_API_CALL DFCSetLogFileName( int connectionNumber, const char *filePath )
{
    ChannelBridge *channelBridge = theApp.channelBridge( connectionNumber );
    // Wurde Channel-Objekt ermittelt.
    if ( channelBridge == nullptr )
    {
        return;
    }

    channelBridge->logBegin( __func__, "\t%s", (filePath == NULL) ? "" : (char*)filePath );

    // Fehlerwert zuruecksetzen.
    channelBridge->setLastErrorNumber( 0, IV_ERROR_SUCCESS );

    // zulaessige Bereiche pruefen
    if ( filePath == nullptr )
    {
        channelBridge->setLastErrorNumber( 0, IV_ERROR_FUNCTION_PARAMETER );
        channelBridge->logEnd( "" );
        return;
    }

    channelBridge->setLogFileName( filePath );

    channelBridge->logEnd( "" );
}

DF_API_EXTERN_DECORATE void DF_API_CALL DFCSetLogOn( int connectionNumber )
{
    ChannelBridge *channelBridge = theApp.channelBridge( connectionNumber );
    // Wurde Channel-Objekt ermittelt.
    if ( channelBridge == nullptr )
    {
        return;
    }

    channelBridge->logBegin( __func__, "" );

    // Fehlerwert zuruecksetzen.
    channelBridge->setLastErrorNumber( 0, IV_ERROR_SUCCESS );

    // Pruefe ob Channel vorhanden
    channelBridge->setLogOn();

    channelBridge->logEnd( "" );
}

DF_API_EXTERN_DECORATE void DF_API_CALL DFCSetLogOff( int connectionNumber )
{
    ChannelBridge *channelBridge = theApp.channelBridge( connectionNumber );
    // Wurde Channel-Objekt ermittelt.
    if ( channelBridge == nullptr )
    {
        return;
    }

    channelBridge->logBegin( __func__, "" );

    // Fehlerwert zuruecksetzen.
    channelBridge->setLastErrorNumber( 0, IV_ERROR_SUCCESS );

    channelBridge->setLogOff();

    channelBridge->logEnd("");
}

DF_API_EXTERN_DECORATE int DF_API_CALL DFCLogOn( const char *filePath )
{
    (void)filePath;
    return 0;
}

DF_API_EXTERN_DECORATE void DF_API_CALL DFCLogOff()
{
}
