/**
* @file  file_device_text.h
* @brief Schnittstelle fuer die Klasse FileDeviceText.
*/
//////////////////////////////////////////////////////////////////////
#pragma once
#ifndef FILE_DEVICE_TEXT_H
#define FILE_DEVICE_TEXT_H

// Basisklasse 
#include "file_intel_hex.h"

// Strukturdefinitionen
#include "interface/device_text_structs.h"
// CRC berechnungsroutinen
#include "common/crc.h"

#include <vector>

#ifdef _MSC_VER
#pragma warning(disable : 4996)
#endif

class FileDeviceText : public FileIntelHex
{
public:
    FileDeviceText();
    virtual ~FileDeviceText();

public:
    void resetData();

    bool load( const std::string &filePath );
    bool save( const std::string &filePath, bool appendToFile = false, bool appendEndLine = true );
    char *DefaultDFL();

    int Import(const std::string &filePath );
    int ParseLineFromHeader(char *data, unsigned short &id, char **format, char **text, unsigned int &flags);
    int ParseLineFromDefault(char *data, unsigned short &id, char **format, char **text, unsigned int &flags);
    void ConvertControlCharacters(char **text);

protected:
    bool loadBin( std::ifstream &fs, std::size_t size );
    bool saveBin( std::ofstream &fs );

public:
    std::vector<unsigned char> bufferDefaultDFL_;
};

#endif

