#pragma once
#ifndef TOUCH_KEYS_STRUCTS_H
#define TOUCH_KEYS_STRUCTS_H

#pragma pack(push, 1)

struct TOUCHKEYNODE_V1
{
    uint8_t version{};
    uint8_t cnt{};
    uint8_t deviceType{};
    uint8_t temp{};
    uint32_t ptrTouchkeyArray{};
};

struct TOUCHKEYNODE_V2
{
    uint8_t version{};
    uint8_t cnt{};
    uint8_t deviceType{};
    uint16_t dpiX{};
    uint16_t dpiY{};
    uint32_t ptrTouchkeyArray{};
};

/*
#define KEY_NO                                   (0)
#define KEY_DUMMY                                (255)
#define KEY_UNDEF                                (255)
#define KEY_SHIFT_ON                             (0x02)
#define KEY_SHIFT_OFF                            (0x03)
#define KEY_CLR                                  (8)
#define KEY_SWITCH                               (12)
#define KEY_CR                                   (13)
#define KEY_ESC                                  (27)
#define KEY_NUM_BLOCK                            (10)

#define KEY_QUOTE                                (34)

#define KEY_PERCENT                              (37)

#define KEY_BR_RD_LE                             (40)
#define KEY_BR_RD_RI                             (41)
#define KEY_ASTERISK                             (42)
#define KEY_PLUS                                 (43)
#define KEY_COMMA                                (44)
#define KEY_MINUS                                (45)
#define KEY_DOT                                  (46)
#define KEY_SLASH                                (47)
#define KEY_0                                    (48)
#define KEY_1                                    (49)
#define KEY_2                                    (50)
#define KEY_3                                    (51)
#define KEY_4                                    (52)
#define KEY_5                                    (53)
#define KEY_6                                    (54)
#define KEY_7                                    (55)
#define KEY_8                                    (56)
#define KEY_9                                    (57)
#define KEY_COLON                                (58)
#define KEY_SEMICOLON                            (59)
#define KEY_BR_SQ_LE                             (60)
#define KEY_EQUAL                                (61)
#define KEY_BR_SQ_RI                             (62)

#define KEY_A                                    (65)
#define KEY_B                                    (66)
#define KEY_C                                    (67)
#define KEY_D                                    (68)
#define KEY_E                                    (69)
#define KEY_F                                    (70)
#define KEY_G                                    (71)
#define KEY_H                                    (72)
#define KEY_I                                    (73)
#define KEY_J                                    (74)
#define KEY_K                                    (75)
#define KEY_L                                    (76)
#define KEY_M                                    (77)
#define KEY_N                                    (78)
#define KEY_O                                    (79)
#define KEY_P                                    (80)
#define KEY_Q                                    (81)
#define KEY_R                                    (82)
#define KEY_S                                    (83)
#define KEY_T                                    (84)
#define KEY_U                                    (85)
#define KEY_V                                    (86)
#define KEY_W                                    (87)
#define KEY_X                                    (88)
#define KEY_Y                                    (89)
#define KEY_Z                                    (90)

#define KEY_UNDERLINE                            (95)

#define KEY_F1                                   (112)//entspricht MS VK_F1 70h
#define KEY_F2                                   (113)
#define KEY_F3                                   (114)
#define KEY_F4                                   (115)
#define KEY_F5                                   (116)
#define KEY_F6                                   (117)
#define KEY_F7                                   (118)
#define KEY_F8                                   (119)
#define KEY_F9                                   (120)
#define KEY_F10                                  (121)
#define KEY_F11                                  (122)
#define KEY_F12                                  (123)
#define KEY_F13                                  (124)
#define KEY_F14                                  (125)
#define KEY_F15                                  (126)

#define KEY_SEL_1                                (128)
#define KEY_SEL_2                                (129)
#define KEY_SEL_3                                (130)
#define KEY_SEL_4                                (131)
#define KEY_SEL_5                                (132)
#define KEY_SEL_6                                (133)

#define KEY_UP                                   (144)
#define KEY_DOWN                                 (145)
#define KEY_LEFT                                 (146)
#define KEY_RIGHT                                (147)

#define KEY_M1                                   (160)
#define KEY_M2                                   (161)
#define KEY_M3                                   (162)
#define KEY_M4                                   (163)
// Umgeändert am 30.07.2009
#define KEY_F1                                   (192)//112
#define KEY_F2                                   (193)//113
#define KEY_F3                                   (194)//114
#define KEY_F4                                   (195)//115
#define KEY_F5                                   (196)//116
#define KEY_F6                                   (197)//117
#define KEY_F7                                   (198)//118
#define KEY_F8                                   (199)//119
#define KEY_F9                                   (200)//120
#define KEY_F10                                  (201)//121
#define KEY_F11                                  (202)//122
#define KEY_F12                                  (203)//123

#define KEY_CHECK                                (239)
#define KEY_COM1                                 (240)
#define KEY_SERVICE                              (241)
#define KEY_MONITORING                           (242)
#define KEY_REDRAW                               (243)
#define KEY_MESSAGE                              (244)
#define KEY_EVENT                                (246)
#define KEY_BIOS_MENUE                           (247)
#define KEY_ERROR                                (248)
#define KEY_JUMP                                 (249)
#define KEY_MAIN_MENUE                           (250)
#define KEY_TRANSPONDER_MENUE                    (251)
#define KEY_MMC_MENUE                            (252)
#define KEY_ONOFF                                (254)
*/
#define TOUCHKEY_NONE           0
#define TOUCHKEY_CLR            8
#define TOUCHKEY_ENTER          13
#define TOUCHKEY_ESC            27

//#define TOUCHKEY_SPACE        32  // nicht vorahanden 
//#define TOUCHKEY_EXCL_MARK    33  // !
#define TOUCHKEY_QUOTE          34  // "
//#define TOUCHKEY_HASH         35  // #
//#define TOUCHKEY_DOLLAR       36  // $
#define TOUCHKEY_PERCENT        37  // %
//#define TOUCHKEY_AMPERSAND    38  // &
//#define TOUCHKEY_SINGLE_QUOTE 39  // '

#define TOUCHKEY_BR_RD_LE       40  // (
#define TOUCHKEY_BR_RD_RI       41  // )
#define TOUCHKEY_ASTERISK       42  // *
#define TOUCHKEY_PLUS           43  // +
#define TOUCHKEY_COMMA          44  // ,
#define TOUCHKEY_MINUS          45  // -
#define TOUCHKEY_DOT            46  // .
#define TOUCHKEY_SLASH          47  // /

#define TOUCHKEY_0              48
#define TOUCHKEY_1              49
#define TOUCHKEY_2              50
#define TOUCHKEY_3              51
#define TOUCHKEY_4              52
#define TOUCHKEY_5              53
#define TOUCHKEY_6              54
#define TOUCHKEY_7              55
#define TOUCHKEY_8              56
#define TOUCHKEY_9              57

#define TOUCHKEY_COLON          58   // ,
#define TOUCHKEY_SEMICOLON      59   // ;
#define TOUCHKEY_BR_SQ_LE       60   // <
#define TOUCHKEY_EQUAL          61   // =
#define TOUCHKEY_BR_SQ_RI       62   // >
//#define TOUCHKEY_QUESTION_MARK  63  // ? 
//#define TOUCHKEY_AT_SIGN        64 // @

#define TOUCHKEY_A              65
#define TOUCHKEY_B              66
#define TOUCHKEY_C              67
#define TOUCHKEY_D              68
#define TOUCHKEY_E              69
#define TOUCHKEY_F              70
#define TOUCHKEY_G              71
#define TOUCHKEY_H              72
#define TOUCHKEY_I              73
#define TOUCHKEY_J              74
#define TOUCHKEY_K              75
#define TOUCHKEY_L              76
#define TOUCHKEY_M              77
#define TOUCHKEY_N              78
#define TOUCHKEY_O              79
#define TOUCHKEY_P              80
#define TOUCHKEY_Q              81
#define TOUCHKEY_R              82
#define TOUCHKEY_S              83
#define TOUCHKEY_T              84
#define TOUCHKEY_U              85
#define TOUCHKEY_V              86
#define TOUCHKEY_W              87
#define TOUCHKEY_X              88
#define TOUCHKEY_Y              89
#define TOUCHKEY_Z              90

//#define TOUCHKEY_91          91  // '['
//#define TOUCHKEY_92          92  // '\'
//#define TOUCHKEY_93          93  // ']'
//#define TOUCHKEY_94          94  // '^'

#define TOUCHKEY_UNDERLINE      95  // '_'
//#define TOUCHKEY_96        96  // '`'

// Hier kommen die Kleinbuchstaben bei der Normalen Tastatur
#define TOUCHKEY_F1             112 // ist eigentlich das "p"
#define TOUCHKEY_F2             113
#define TOUCHKEY_F3             114
#define TOUCHKEY_F4             115
#define TOUCHKEY_F5             116
#define TOUCHKEY_F6             117
#define TOUCHKEY_F7             118
#define TOUCHKEY_F8             119
#define TOUCHKEY_F9             120
#define TOUCHKEY_F10            121
#define TOUCHKEY_F11            122
#define TOUCHKEY_F12            123
#define TOUCHKEY_F13            124
#define TOUCHKEY_F14            125
#define TOUCHKEY_F15            126
#define TOUCHKEY_UP             144
#define TOUCHKEY_DOWN           145
#define TOUCHKEY_LEFT           146
#define TOUCHKEY_RIGHT          147

#define TOUCHKEY_BIOS_MENUE     247
#define TOUCHKEY_ONOFF          254

// Die Tastenrahmen beziehen sich auf die obere linke Ecke des Touch der Aktiv Area
struct TOUCHKEY_V1
{
    uint8_t flags{};    // Zusatzflags zur Taste
    uint8_t key{};      // Tastencode gemäß Tabelle in Firmwaredefinition (F1 -> 112)
    uint8_t left{};     // Anfang Tastenrahmen linke Seite in mm.
    uint8_t top{};      // Anfang Tastenrahmen obere Seite in mm.
    uint8_t right{};    // Ende Tastenrahmen rechte Seite in mm.
    uint8_t bottom{};   // Ende Tastenrahmen untere Seite in mm.
    uint8_t tmp[2]{};   // Reserve

    TOUCHKEY_V1()
    {
    }

    TOUCHKEY_V1( uint8_t k, uint8_t l, uint8_t t, uint8_t r, uint8_t b )
        : key(k)
        , left(l)
        , top(t)
        , right(r)
        , bottom(b)
    {
    }
};

struct TOUCHKEY_V2
{
    uint8_t flags{};    // Zusatzflags zur Taste
    uint8_t key{};      // Tastencode gemäß Tabelle in Firmwaredefinition (F1 -> 112)
    uint16_t left{};    // Anfang Tastenrahmen linke Seite in px.
    uint16_t top{};     // Anfang Tastenrahmen obere Seite in px.
    uint16_t right{};   // Ende Tastenrahmen rechte Seite in px.
    uint16_t bottom{};  // Ende Tastenrahmen untere Seite in px.

    TOUCHKEY_V2()
    {
    }

    TOUCHKEY_V2( uint8_t k, uint16_t l, uint16_t t, uint16_t r, uint16_t b )
        : key( k )
        , left( l )
        , top( t )
        , right( r )
        , bottom( b )
    {
    }
};

#pragma pack(pop)

#endif
