#include "file/interface/dfitem/dfitem_input_chain.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemInputChain::CDFItemInputChain( tinyxml2::XMLDocument *doc ) : CDFItemBase( doc )
{
    xmlElement()->SetText( "ItemInputChain" );

    // Member initialisieren
    m_ulFlashOffset = 0;
}

CDFItemInputChain::~CDFItemInputChain()
{

}

int CDFItemInputChain::Modify( CModifyData &modifyData )
{
    int i;
    unsigned int offs = modifyData.offsFlash, offsChilds;
    CDFItemBase *item;

    // Daten von Bedien - Struktur uebernehmen
    StructOperating &bedien = *(StructOperating *)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
    ChangeOrderLong( (unsigned char *)&bedien.ptr );
    offs += sizeof( StructOperating );

    // Offset abziehen, da Erweitertes - Flash hinter Setupdaten.
    bedien.ptr -= m_ulFlashOffset;

    // Daten von DatensatzEinlesen - Struktur uebernehmen
    StructReadRecord &datensatzEinlesen = *(StructReadRecord *)&modifyData.file->m_flash[offs - FLASH_KONFIG_START];
    ChangeOrderLong( (unsigned char *)&datensatzEinlesen.ptr );
    offs += sizeof( StructReadRecord );

    // Offset abziehen, da Erweitertes - Flash hinter Setupdaten.
    datensatzEinlesen.ptr -= m_ulFlashOffset;

    // Namen aendern?
    strcpy( datensatzEinlesen.name, LookupReplace( modifyData, datensatzEinlesen.name ).c_str() );

    // Daten aller Eintraege einlesen
    for ( i = 0; i < (int)datensatzEinlesen.fields; ++i )
    {
        offsChilds = datensatzEinlesen.ptr + i * sizeof( unsigned int );	// Pointer des Eintrags berechnen

        offsChilds = *(unsigned int *)&modifyData.file->m_flash[offsChilds - FLASH_KONFIG_START];
        ChangeOrderLong( (unsigned char *)&offsChilds );
        // Bei ExtendedFlash mit Offset		
        offsChilds -= m_ulFlashOffset;

        item = new CDFItemInputChainField( xmlElement()->GetDocument() );
        xmlElement()->InsertEndChild( item->xmlElement() );
        modifyData.offsFlash = offsChilds;
        item->Modify( modifyData );
    }

    // Adressen zurueckkonvertieren
    ChangeOrderLong( (unsigned char *)&bedien.ptr );
    ChangeOrderLong( (unsigned char *)&datensatzEinlesen.ptr );

    return 1;
}
